%\version "2.14.0"
\version "2.12.3"

\header {
  texidoc = "
Use this code to produce an alternative version of a tablature to a
piece of music played with a open-tuning.

With only one directive passed via the command line (or an option set
at the top of the file), you can get either a tablature of that piece
in open-tuning (if any) or a tablature of the piece in a normal tuning
(less pure, but more usable).

%%%% TODO replace:

%% Note that the \"normal tuning\" for a six-string guitar is (+4 -1 -5
%% -10 -15 -20) for (e b g d a e). The code shows an alternative with an
%% open-tuning of D ( (+2 -3 -6 -10 -15 -22) ). You should change this
%% list if you want another open-tuning, knowing that the first number is
%% the first string, so high E, and the numbers start from C. So the
%% example above is for D (+2) A (-3) F# (-6) D (-10) A (-15) D (-22). 

"
  doctitle = "Obtaining a tablature for open-tuning and/or normal tuning"
}
%% LSR: Thanks to Nicolas Sceaux for the final code.

%% To switch to open tuning, either compile the file with
%% -dopen-tuning option, or uncomment the following line:
%% #(ly:set-option 'open-tuning #t)

%%%% TODO better implementation with makeStringTuning?
%%%% TODO handle the log-warning: warning: no such internal option: open-tuning 

\layout {
  \context {
    \TabStaff
    stringTunings =
      #(if (eqv? (ly:get-option 'open-tuning) #t)
           `(,(ly:make-pitch 0 1 0)
             ,(ly:make-pitch -1 5 0)
             ,(ly:make-pitch -1 3 1/2)
             ,(ly:make-pitch -1 1 0)
             ,(ly:make-pitch -2 5 0)
             ,(ly:make-pitch -2 1 0))
           `(,(ly:make-pitch 0 2 0)
             ,(ly:make-pitch -1 6 0)
             ,(ly:make-pitch -1 4 0)
             ,(ly:make-pitch -1 1 0)
             ,(ly:make-pitch -2 5 0)
             ,(ly:make-pitch -2 2 0))
           )
  }
}

\new TabStaff {
  c'4 d' e' f'
}

